Imports System.Windows.Forms
Imports System.Drawing
Imports System.ComponentModel

''' <summary>
''' 摜{^NXBvbV{^ƃgO{^̋@\
''' </summary>
''' <remarks></remarks>
<DefaultEvent("Click")> _
Public Class ImageButtonCtl
    Implements IButtonControl
    Private Enum ButtonMode
        Normal = 1
        Hover = 2
        Pressed = 3
        Disabled = 4
    End Enum

    Public Enum ButtonType
        PushButton
        ToggleButton
    End Enum

    Public Sub New()
        MyBase.New()

        Me.SetStyle(ControlStyles.SupportsTransparentBackColor, True)
        Me.SetStyle(ControlStyles.UserPaint, True)
        Me.SetStyle(ControlStyles.DoubleBuffer, True)
        Me.SetStyle(ControlStyles.Opaque, True)
        ' ̌ĂяóAWindows tH[ fUCiŕKvłB
        InitializeComponent()

        ' InitializeComponent() Ăяǒŏǉ܂B
    End Sub


    Private m_normalImage As Image = Nothing
    ''' <summary>
    ''' {^ɕ\C[WiWj
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    <Category("C[W{^")> _
    <Description("{^ɕ\C[WiWj")> _
    <DefaultValue(GetType(Image), Nothing)> _
    Public Property NormalImage() As Image
        Get
            Return Me.m_normalImage
        End Get
        Set(ByVal value As Image)
            Me.m_normalImage = value
            If Me.m_normalImage IsNot Nothing Then
                Me.Size = Me.m_normalImage.Size
            End If
            Me.Refresh()
        End Set
    End Property ' NormalImage

    Private m_hoverImage As Image
    ''' <summary>
    ''' }EX|Cg{^̈ɓƂɕ\C[W
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    <Category("C[W{^")> _
    <Description("}EX|Cg{^̈ɓƂɕ\C[W")> _
    <DefaultValue(GetType(Image), Nothing)> _
    Public Property HoverImage() As Image
        Get
            Return Me.m_hoverImage
        End Get
        Set(ByVal value As Image)
            Me.m_hoverImage = value
            Me.Refresh()
        End Set
    End Property ' HoverImage

    Private m_pressedImage As Image
    ''' <summary>
    ''' {^ꂽƂɕ\C[W
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    <Category("C[W{^")> _
    <Description("{^ꂽƂɕ\C[W")> _
    <DefaultValue(GetType(Image), Nothing)> _
    Public Property PressedImage() As Image
        Get
            Return Me.m_pressedImage
        End Get
        Set(ByVal value As Image)
            Me.m_pressedImage = value
            Me.Refresh()
        End Set
    End Property ' HoverImage

    Private m_disabledImage As Image
    ''' <summary>
    ''' {^̂Ƃɕ\C[W
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    <Category("C[W{^")> _
    <Description("{^̂Ƃɕ\C[W")> _
    <DefaultValue(GetType(Image), Nothing)> _
    Public Property DisabledImage() As Image
        Get
            Return Me.m_disabledImage
        End Get
        Set(ByVal value As Image)
            Me.m_disabledImage = value
            Me.Refresh()
        End Set
    End Property ' DisabledImage

    Private m_transparencyKeyColor As Color = Color.Empty
    ''' <summary>
    ''' `悳Ď̓ɕ\F
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    <Category("C[W{^")> _
    <Description("`悳Ď̓ɕ\F")> _
    <DefaultValue(GetType(Color), "Color.Empty")> _
    Public Property TransparencyKeyColor() As Color
        Get
            Return m_transparencyKeyColor
        End Get
        Set(ByVal value As Color)
            Me.m_transparencyKeyColor = value
            Me.Refresh()
        End Set
    End Property

    Private m_btntype As ButtonType = ButtonType.PushButton
    ''' <summary>
    ''' {^̎
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    <Category("C[W{^")> _
    <Description("{^̎")> _
    <DefaultValue(GetType(ButtonType), "PushButton")> _
    Public Property BtnType() As ButtonType
        Get
            Return m_btntype
        End Get
        Set(ByVal value As ButtonType)
            m_btntype = value
        End Set
    End Property

    Private m_pushState As Boolean = False
    ''' <summary>
    ''' gO{^̎̃{^̏
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    <Category("C[W{^")> _
    <Description("gO{^̎̃{^̏")> _
    <DefaultValue(False)> _
    Public Property PushState() As Boolean
        Get
            Return m_pushState
        End Get
        Set(ByVal value As Boolean)
            m_pushState = value
        End Set
    End Property

    Private m_PushedHoverImage As Image
    ''' <summary>
    ''' {^̂Ƃɕ\C[W
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    <Category("C[W{^")> _
    <Description("gO{^̎AĂ鎞ɃtH[JX̃C[W")> _
    <DefaultValue(GetType(Image), Nothing)> _
    Public Property PushedHoverImage() As Image
        Get
            Return m_PushedHoverImage
        End Get
        Set(ByVal value As Image)
            m_PushedHoverImage = value
        End Set
    End Property

    Private m_dialogResult As DialogResult = Windows.Forms.DialogResult.OK
    ''' <summary>
    ''' {^NbN邱ƂɂāA[_`ō쐬_CAǑ
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    <Category("C[W{^")> _
    <Description("{^NbN邱ƂɂāA[_`ō쐬_CAǑ")> _
    <DefaultValue(GetType(System.Windows.Forms.DialogResult), "OK")> _
    Public Property DialogResult() As System.Windows.Forms.DialogResult Implements System.Windows.Forms.IButtonControl.DialogResult

        Get
            Return Me.m_dialogResult
        End Get

        Set(ByVal value As System.Windows.Forms.DialogResult)
            Me.m_dialogResult = value
        End Set

    End Property ' DialogResult
    Public Sub NotifyDefault(ByVal in_amIDefault As Boolean) Implements System.Windows.Forms.IButtonControl.NotifyDefault
    End Sub ' NotifyDefault

    ''' <summary>
    ''' ' Cxgf[^񋟂郁\bh̒`
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub PerformClick() Implements System.Windows.Forms.IButtonControl.PerformClick

        If Me.Enabled Then
            RaiseEvent Click()  ' Click Cxg𔭐
        End If

    End Sub ' PerformClick

    Private m_currentMode As ButtonMode = ButtonMode.Normal
    ''' <summary>
    '''  ĕ`悪KvȂƂɔ
    ''' </summary>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Protected Overrides Sub OnPaint(ByVal e As System.Windows.Forms.PaintEventArgs)
        DrowButtonMode(e.Graphics)
    End Sub
    ''' <summary>
    ''' Rg[̗LԂύXꂽƂɔ
    ''' </summary>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Protected Overrides Sub OnEnabledChanged(ByVal e As System.EventArgs)
        If Me.Enabled = False Then
            Me.m_currentMode = ButtonMode.Disabled
        End If
        Me.Refresh()
    End Sub ' OnEnabledChanged

    ''' <summary>
    ''' {^̏Ԃ擾AC[W`悷
    ''' </summary>
    ''' <param name="g"></param>
    ''' <remarks></remarks>
    Private Sub DrowButtonMode(ByVal g As Graphics)
        Select Case m_currentMode
            Case ButtonMode.Normal          ' W
                If BtnType = ButtonType.ToggleButton And PushState = True Then
                    DrowButton(g, PressedImage)
                Else
                    DrowButton(g, NormalImage)
                End If
            Case ButtonMode.Pressed         ' {^Ăꍇ
                DrowButton(g, PressedImage)
            Case ButtonMode.Hover           ' }EX|Cg{^̈ɓĂꍇ
                If BtnType = ButtonType.ToggleButton And PushState = True And PushedHoverImage IsNot Nothing Then
                    DrowButton(g, PushedHoverImage)
                Else
                    DrowButton(g, HoverImage)
                End If
            Case ButtonMode.Disabled        ' {^̏ꍇ
                DrowButton(g, DisabledImage)
        End Select
    End Sub

    ''' <summary>
    ''' C[W`悷
    ''' </summary>
    ''' <param name="g"></param>
    ''' <param name="imgButton"></param>
    ''' <remarks></remarks>
    Private Sub DrowButton(ByVal g As Graphics, ByVal imgButton As Image)
        If NormalImage IsNot Nothing Then
            If imgButton Is Nothing Then
                imgButton = NormalImage
            End If
            Dim img As Bitmap = CType(imgButton, Bitmap)
            If TransparencyKeyColor <> Color.Empty Then
                img.MakeTransparent(TransparencyKeyColor)
            End If
            g.DrawImage(img, 0, 0, img.Width, img.Height)           ' C[W`悷
        End If
    End Sub
    Private Sub SetDrowButtonMode(ByVal buttonMode As ButtonMode)
        If m_currentMode <> buttonMode Then
            m_currentMode = buttonMode
            Me.Refresh()
        End If
    End Sub

    ''' <summary>
    ''' }EX|Cg\̈ɓƂ
    ''' </summary>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Protected Overrides Sub OnMouseEnter(ByVal e As System.EventArgs)
        SetDrowButtonMode(ButtonMode.Hover)
    End Sub

    ''' <summary>
    ''' }EX|Cg\̈悩痣ꂽƂ
    ''' </summary>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Protected Overrides Sub OnMouseLeave(ByVal e As System.EventArgs)
        If Me.Enabled = False Then
            Return
        End If
        SetDrowButtonMode(ButtonMode.Normal)
    End Sub

    ''' <summary>
    ''' }EX{^Ƃ
    ''' </summary>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Protected Overrides Sub OnMouseDown(ByVal e As System.Windows.Forms.MouseEventArgs)
        If IsEnableArea(e.X, e.Y) = True Then
            If e.Button And Windows.Forms.MouseButtons.Left Then
                SetDrowButtonMode(ButtonMode.Pressed)
                Me.Capture = True
                Me.Focus()
            End If
        End If
    End Sub ' OnMouseDown

    ''' <summary>
    ''' }EX{^ꂽƂ
    ''' </summary>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Protected Overrides Sub OnMouseUp(ByVal e As System.Windows.Forms.MouseEventArgs)
        If IsEnableArea(e.X, e.Y) = True Then
            If e.Button And Windows.Forms.MouseButtons.Left Then
                Me.Capture = False
                If e.X > 0 And e.Y > 0 And e.X < Me.Width And e.Y < Me.Height Then
                    SetDrowButtonMode(ButtonMode.Hover)
                Else
                    SetDrowButtonMode(ButtonMode.Normal)
                End If
                If e.X > 0 And e.Y > 0 And e.X < Me.Width And e.Y < Me.Height Then
                    If BtnType = ButtonType.ToggleButton Then ' ToggleButton
                        Me.PushState = Not Me.PushState
                    End If
                    PerformClick()
                    Invalidate()
                End If
            End If
        End If
    End Sub ' OnMouseUp

    ''' <summary>
    ''' }EX|C^ړƂ
    ''' </summary>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Protected Overrides Sub OnMouseMove(ByVal e As System.Windows.Forms.MouseEventArgs)
        If IsEnableArea(e.X, e.Y) = True Then
            If (e.Button = Windows.Forms.MouseButtons.Left) Then
                If e.X > 0 And e.X < Me.Width And e.Y > 0 And e.Y < Me.Height Then
                    SetDrowButtonMode(ButtonMode.Pressed)
                Else
                    SetDrowButtonMode(ButtonMode.Normal)
                End If
            End If
        End If
    End Sub ' OnMouseMove

    Private Function IsEnableArea(ByVal x As Integer, ByVal y As Integer)
        If Me.NormalImage Is Nothing Then
            Return False
        End If
        If Me.m_currentMode = ButtonMode.Disabled Then
            Return False
        End If
        Dim img As Bitmap = CType(NormalImage, Bitmap)
        If x > 0 And x < img.Width And y > 0 And y < img.Height Then
            Dim c As Color = img.GetPixel(x, y)
            If c.A = 0 Then
                Return False
            End If
        End If
        Return True
    End Function

    'CxgfQ[g̐錾
    Public Shadows Event Click()
End Class
