Imports System.Collections
Imports System.ComponentModel
Imports System.Drawing.Imaging
Imports System.IO
Imports System.Reflection
Imports System.Runtime.InteropServices

''' <summary>
''' C[WǗp̍\
''' </summary>
''' <remarks></remarks>
Public Structure ImageData
    Public img As Image
    Public strName As String
    Public strFile As String
    Public strTitle As String
    Public strComment As String
    Public bLoaded As Boolean
    Public bReloading As Boolean
    Public bSelected As Boolean
End Structure

''' <summary>
''' C[WǗNXBArrayListpAImageDatãXgƂ
''' </summary>
''' <remarks></remarks>
<DefaultEvent("SendEvent")> _
Public Class ImageDataList
    Inherits ArrayList

#Region "`EϐECxg"
    Public Event SendEvent As System.EventHandler
    Private m_thumbSize As Size
    Private m_thrd As System.Threading.Thread
    Private m_bModItem As Boolean
    Private m_bForceReload As Boolean
    Private m_bBreak As Boolean

#End Region

#Region "VXe֐"
    Public Sub New()
        m_bBreak = False
        m_bModItem = False
    End Sub

    ''' <summary>
    ''' Xgւ̃ACeǉ
    ''' </summary>
    ''' <param name="Value"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Shadows Function Add(ByVal Value As ImageData) As Integer
        m_bModItem = True
        Return MyBase.Add(Value)
    End Function

    ''' <summary>
    ''' Xg̃NA
    ''' </summary>
    ''' <remarks></remarks>
    Public Shadows Sub Clear()
        m_bForceReload = True
        MyBase.Clear()
    End Sub
#End Region

#Region "[U[֐"
    ''' <summary>
    ''' B̃NXgpƂɕKĂяo
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub Init()
        m_thrd = New System.Threading.Thread(AddressOf ImageLoadThread)
        m_thrd.Priority = Threading.ThreadPriority.BelowNormal
        m_bForceReload = False
        m_thrd.Start()
    End Sub

    ''' <summary>
    ''' XbhI
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub StopThread()
        m_bBreak = True
        If m_thrd Is Nothing Then
            Return
        End If
        Do While m_thrd.ThreadState = Threading.ThreadState.Running
            System.Threading.Thread.Sleep(500)
        Loop
    End Sub

    ''' <summary>
    ''' ̃t@Ĉݍēǂݍ݂s
    ''' </summary>
    ''' <param name="sName"></param>
    ''' <remarks></remarks>
    Public Sub ReloadFile(ByVal sName As String)
        Dim myData As ImageData = Nothing
        Dim i As Integer
        For i = 0 To Me.Count - 1
            Try
                myData = Me(i)

                If myData.strName = sName Then
                    myData.bReloading = True
                    Me(i) = myData
                End If

            Catch ex As Exception

            End Try
        Next
        m_bModItem = True
    End Sub
#End Region


    ''' <summary>
    ''' 摜ǂݍ݃XbhBɓ삳AAvP[V\Ȃ܂ܓǂݍ݁Eēǂݍ݂s
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub ImageLoadThread()
        Dim myData As ImageData = Nothing
        Dim i As Integer
        Dim cnt As Integer
        Dim cntMax As Integer = 9
        Dim imgOrg As Image
        Dim sizThumb As Size
        Dim sizThumbB As Size
        Dim pr1, pr2 As Double

        Do While m_bBreak = False
            If m_bModItem Then

                If IsDBNull(m_thumbSize) Or m_thumbSize.IsEmpty Then
                    sizThumb = New Size(100, 100)
                Else
                    sizThumb = m_thumbSize
                End If

                m_bModItem = False
                cnt = 0
                For i = 0 To (Me.Count - 1)
                    Try
                        myData = Me(i)

                        If myData.bLoaded = False Or myData.bReloading = True Then
                            myData.strComment = ""
                            myData.strTitle = ""
                            myData.bReloading = False
                            Try ' NTFSXg[^CgERgǂݍށiDSOFilegpj
                                Dim oSummProps As DSOFile.SummaryProperties
                                Dim oDocument As DSOFile.OleDocumentPropertiesClass
                                oDocument = New DSOFile.OleDocumentPropertiesClass()

                                oDocument.Open(myData.strName, True, DSOFile.dsoFileOpenOptions.dsoOptionOpenReadOnlyIfNoWriteAccess)
                                oSummProps = oDocument.SummaryProperties
                                myData.strComment = oSummProps.Comments
                                myData.strTitle = oSummProps.Title
                                oDocument.Close()
                            Catch ex As Exception

                            End Try

                            imgOrg = ImageLibs.FromFile(myData.strName)
                            pr1 = sizThumb.Height / sizThumb.Width
                            pr2 = imgOrg.Height / imgOrg.Width
                            sizThumbB = sizThumb
                            If pr1 < pr2 Then ' C[Wcɒꍇ
                                sizThumbB.Width = sizThumbB.Width * (pr1 / pr2)
                            Else
                                sizThumbB.Height = sizThumbB.Height * (pr2 / pr1)
                            End If
                            myData.img = ImageLibs.CreateThumbnail(imgOrg, sizThumbB.Width, sizThumbB.Height)

                            imgOrg.Dispose()

                            myData.bLoaded = True
                            If m_bForceReload Then
                                m_bForceReload = False
                                m_bModItem = True
                                cnt = 0
                                Exit For
                            End If
                            Me(i) = myData
                            cnt = cnt + 1
                        End If

                        If cnt >= cntMax Then
                            Try
                                cnt = 0
                                RaiseEvent SendEvent(Me, EventArgs.Empty) ' ǂݍݖɍXVCxg𔭍s
                            Catch ex As Exception

                            End Try
                        End If

                    Catch ex As Exception
                        If i >= Me.Count Then
                            m_bModItem = True
                            cnt = 1
                            Exit For
                        End If
                        ' TlC쐬ŃG[oACe͏
                        MyBase.RemoveAt(i)
                        i = i - 1
                    End Try
                Next
                If cnt > 0 Then
                    Try
                        RaiseEvent SendEvent(Me, EventArgs.Empty) ' ǂݍ݂XVCxg𔭍s
                    Catch ex As Exception

                    End Try
                End If
            End If

            If Not m_bModItem Then
                System.Threading.Thread.Sleep(100)
            End If
        Loop
    End Sub


#Region "vpeB"
    Public Shadows Property Item(ByVal Index As Integer) As ImageData
        Get
            Return MyBase.Item(Index)
        End Get
        Set(ByVal Value As ImageData)
            MyBase.Item(Index) = Value
        End Set
    End Property

    ''' <summary>
    ''' ACȇIԂݒE擾
    ''' </summary>
    ''' <param name="Index"></param>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Selected(ByVal Index As Integer) As Boolean
        Get
            If Index < 0 Or Index >= Me.Count Then
                Return False
            End If
            Return Me.Item(Index).bSelected
        End Get
        Set(ByVal value As Boolean)
            If Index < 0 Or Index >= Me.Count Then
                Return
            End If
            Dim imgd As ImageData
            imgd = MyBase.Item(Index)
            imgd.bSelected = value
            MyBase.Item(Index) = imgd
        End Set
    End Property

    ''' <summary>
    ''' TlCTCYݒE擾
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property ThumbSize() As Size
        Get
            Return m_thumbSize
        End Get
        Set(ByVal value As Size)
            m_thumbSize = value
        End Set
    End Property

    ''' <summary>
    ''' IS
    ''' </summary>
    ''' <remarks></remarks>
    Public Sub ClearSelect()
        Dim i As Integer
        For i = 0 To Me.Count - 1
            Selected(i) = False
        Next
    End Sub
#End Region

End Class

#Region "ImageLibs NX"
''' <summary>
''' ɉ摜C[W[h邽߂̃NX
''' </summary>
''' <remarks></remarks>
Public Class ImageLibs
    ' GDI+  GdipLoadImageFromFile() 錾
    <DllImport("gdiplus.dll", CharSet:=CharSet.Unicode)> _
    Public Shared Function GdipLoadImageFromFile(ByVal strFileName As String, ByRef ipImage As IntPtr) As Integer
    End Function
    ' Bitmap ^擾
    Private Shared imageType As Type = GetType(System.Drawing.Bitmap)

    ' RXgN^
    Public Sub New()
    End Sub

    ''' <summary>
    ''' w肳ꂽt@C獂ɉ摜C[W[hAImage 쐬܂B
    ''' </summary>
    ''' <param name="strFileName">Image ̍쐬ƂȂt@C̖O܂܂Ă镶B </param>
    ''' <returns>̃\bh쐬 ImageB </returns>
    ''' <remarks></remarks>
    Public Shared Function FromFile(ByVal strFileName As String) As Image
        'w肵pX̐΃pX֕ϊ
        strFileName = Path.GetFullPath(strFileName)
        Dim ipLoadImage As IntPtr = IntPtr.Zero

        ' 摜C[W̃[h
        Dim iRet As Integer = GdipLoadImageFromFile(strFileName, ipLoadImage)
        If iRet <> 0 Then
            Throw New Exception("GdipLoadImageFromFile() ŃG[܂B G[ F" + iRet.ToString())
        End If

        ' nh Bitmap IuWFNgɕϊ 
        Return CType(imageType.InvokeMember("FromGDIplus", BindingFlags.NonPublic Or BindingFlags.Static Or BindingFlags.InvokeMethod, Nothing, Nothing, New Object() {ipLoadImage}), Bitmap)
    End Function

    Private Shared Function GetEncoderInfo(ByVal mimeType As String) As ImageCodecInfo
        Dim j As Integer
        Dim encoders() As ImageCodecInfo
        encoders = ImageCodecInfo.GetImageEncoders()

        j = 0
        While j < encoders.Length
            If encoders(j).MimeType = mimeType Then
                Return encoders(j)
            End If
            j += 1
        End While
        Return Nothing

    End Function 'GetEncoderInfo

    ''' <summary>
    ''' TlC摜쐬iC[WLkj
    ''' </summary>
    ''' <param name="img">̃C[W</param>
    ''' <param name="iWidth">k̕</param>
    ''' <param name="iHeight">k̍</param>
    ''' <returns>ϊꂽ̉摜</returns>
    ''' <remarks></remarks>
    Public Shared Function CreateThumbnail(ByVal img As Image, ByVal iWidth As Integer, ByVal iHeight As Integer) As Image
        Dim bmp As Bitmap = New Bitmap(iWidth, iHeight)
        Dim g As Graphics = Graphics.FromImage(bmp)
        g.FillRectangle(Brushes.White, 0, 0, iWidth, iHeight)

        Dim fw As Single = iWidth / img.Width
        Dim fh As Single = iHeight / img.Height

        Dim fScale As Single = Math.Min(fw, fh)
        fw = img.Width * fScale
        fh = img.Height * fScale

        g.DrawImage(img, (iWidth - fw) / 2, (iHeight - fh) / 2, fw, fh)
        g.Dispose()
        Return bmp
    End Function

    ''' <summary>
    ''' 摜]ĕۑB
    ''' </summary>
    ''' <param name="strFileName">pX܂ރt@C</param>
    ''' <param name="rotate">System.Drawing.RotateFlipType ɂ]</param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Shared Function ImageRotate(ByVal strFileName As String, ByVal rotate As RotateFlipType) As Integer
        Dim myImageCodecInfo As ImageCodecInfo
        Dim myEncoder As Encoder
        Dim myEncoderParameter As EncoderParameter
        Dim myEncoderParameters As EncoderParameters
        Dim img As Image
        Dim bmp As Bitmap
        Dim fmt As System.Drawing.Imaging.ImageFormat

        img = ImageLibs.FromFile(strFileName)
        'img = Image.FromFile(imgd.strName)
        img.RotateFlip(rotate)
        'img.Save(imgd.strName, img.RawFormat)
        bmp = New Bitmap(strFileName)
        fmt = bmp.RawFormat
        bmp.Dispose()
        System.GC.Collect()
        System.GC.WaitForPendingFinalizers()

        ' JPEG摜̏ꍇ̕iǗ(ł80%Œōs)
        If fmt.Guid.ToString = Imaging.ImageFormat.Jpeg.Guid.ToString Then
            myImageCodecInfo = GetEncoderInfo("image/jpeg")
            myEncoder = Encoder.Quality
            myEncoderParameters = New EncoderParameters(1)
            myEncoderParameter = New EncoderParameter(myEncoder, 80)
            myEncoderParameters.Param(0) = myEncoderParameter

            img.Save(strFileName, myImageCodecInfo, myEncoderParameters)
        Else
            img.Save(strFileName, fmt)
        End If

        Return 0
    End Function

End Class
#End Region
