Imports System.ComponentModel

Public Class GraphicCollectorMain
#Region "`E[JϐECxg"
    <Category("GraphicCollectorMain")> _
    <Description("{^Cxg")> _
    Public Event CloseEvent()
    <Category("GraphicCollectorMain")> _
    <Description("ŏ{^Cxg")> _
    Public Event MinimizeEvent()
    <Category("GraphicCollectorMain")> _
    <Description("ő剻{^Cxg")> _
    Public Event MaximizeEvent()

    Private prop_WinState As FormWindowState = FormWindowState.Normal
    Private m_sshow As SlideShowForm
    Private m_bAutoColMode As Boolean = False
    Private m_iPage As Integer = 0
#End Region

#Region "ʏVXe֐"
    Public Sub New()

        ' ̌ĂяóAWindows tH[ fUCiŕKvłB
        InitializeComponent()

        Me.SetStyle(ControlStyles.UserPaint, True)
        Me.SetStyle(ControlStyles.AllPaintingInWmPaint, True)
        Me.SetStyle(ControlStyles.DoubleBuffer, True)
        ' InitializeComponent() Ăяǒŏǉ܂B
    End Sub

    ''' <summary>
    ''' C̓ǂݍ݁Bݒf[^ǂݍ݂Ɖʂ̏s
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub GraphicCollectorMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ComboColumn.Text = ComboColumn.Items(0)
        If Me.DesignMode Then
            Return
        End If

        BtnComment.PushState = My.Settings.ShowComment
        BtnTitle.PushState = My.Settings.ShowTitle
        TrackThumbsize.Value = My.Settings.ThumbZoom
        PhotoListCtl1.ShowComment = My.Settings.ShowComment
        PhotoListCtl1.ShowFileName = My.Settings.ShowTitle
        If My.Settings.MainWindowPos.X >= 0 Then
            If My.Settings.MainWindowPos.X <= SystemInformation.VirtualScreen.Width Then
                If My.Settings.MainWindowPos.Y <= SystemInformation.VirtualScreen.Height Then
                    Me.ParentForm.Location = My.Settings.MainWindowPos
                End If
            End If
        End If

        If My.Settings.MainWindowSize.Width >= 0 Then
            If My.Settings.MainWindowSize.Width <= SystemInformation.VirtualScreen.Width Then
                If My.Settings.MainWindowSize.Height <= SystemInformation.VirtualScreen.Height Then
                    If My.Settings.MainWindowSize.Width > Me.MinWindowSize.Width Then
                        If My.Settings.MainWindowSize.Height > Me.MinWindowSize.Height Then
                            Me.ParentForm.Size = My.Settings.MainWindowSize
                        End If
                    End If
                End If
            End If
        End If

        m_bAutoColMode = True
        TrackThumbsize.Init()
        FolderTreeView1.InitView()
        PhotoListCtl1.InitView()

        PhotoListCtl1.ThumbSize = New Size(600 - TrackThumbsize.Value * 12, 400 - TrackThumbsize.Value * 8)
        PhotoListCtl1.AutoColumn()
    End Sub

    ''' <summary>
    ''' c[IꂽAXgXV
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub FolderTreeView1_AfterSelect(ByVal sender As System.Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles FolderTreeView1.AfterSelect
        PhotoListCtl1.SetImages(FolderTreeView1.SelectedNode.Name)
    End Sub

    ''' <summary>
    ''' TCYύXꂽ̏BZp[^ƁAJݒ̏s
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub GraphicCollectorMain_Resize(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Resize
        Dim szSCMargin As Size = New Size(40, 127)
        If Me.ClientSize.Width > SplitContainer1.Location.X + szSCMargin.Width And Me.ClientSize.Height > SplitContainer1.Location.Y + szSCMargin.Height Then
            SplitContainer1.Size = New Size(Me.ClientSize.Width - (SplitContainer1.Location.X + szSCMargin.Width), Me.ClientSize.Height - (SplitContainer1.Location.Y + szSCMargin.Height))
        End If

        If m_bAutoColMode = True Then
            PhotoListCtl1.AutoColumn()
        End If
    End Sub

    ''' <summary>
    ''' C[Ẅ
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub PrintDocument1_PrintPage(ByVal sender As System.Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles PrintDocument1.PrintPage

        Dim imgdl As ImageDataList
        Dim col As Integer = PhotoListCtl1.Columns
        Dim lines As Integer
        Dim cnt As Integer = 0
        Dim cntIn As Integer = 0
        Dim sizImage As Size = New Size()
        Dim sizFont As SizeF
        Dim img As Image
        Dim x As Integer
        Dim y As Integer
        Const WSpace As Integer = 4
        Const HSpace As Integer = 8
        Dim h As Integer
        Dim bShowComment As Boolean = PhotoListCtl1.ShowComment
        Dim bShowName As Boolean = PhotoListCtl1.ShowFileName
        Dim f As Font = New Font("MS SVbN", 9)
        Dim ThumbSize As Size
        Dim pr1, pr2 As Double
        Dim ThumbMargin As Size
        Dim rcText As RectangleF
        Dim rect2 As Rectangle

        ' IĂ摜̃Xg擾
        imgdl = PhotoListCtl1.SelectedImages
        If imgdl Is Nothing Then
            imgdl = PhotoListCtl1.AllImages
        ElseIf imgdl.Count <= 0 Then ' IĂ摜ȂSΏۂƂ
            imgdl = PhotoListCtl1.AllImages
        End If
        If imgdl Is Nothing Then
            MessageBox.Show("摜܂", My.Application.Info.Title, MessageBoxButtons.OK)
            e.Cancel = True
            Return
        End If

        sizImage.Width = (e.MarginBounds.Width / col) - WSpace
        sizImage.Height = sizImage.Width * 2 / 3
        h = sizImage.Height + HSpace
        sizFont = e.Graphics.MeasureString("|", f)

        If bShowName Then
            h += sizFont.Height
        End If
        If bShowComment Then
            h += sizFont.Height
        End If
        lines = Int(e.MarginBounds.Height / h)

        For Each imgd As ImageData In imgdl
            If (m_iPage * lines * col > cnt) Or ((m_iPage + 1) * lines * col <= cnt) Then
                cnt += 1
                Continue For
            End If

            img = ImageLibs.FromFile(imgd.strName)
            x = (cntIn Mod col) * (sizImage.Width + WSpace) + e.MarginBounds.Left
            y = Int(cntIn / col) * h + e.MarginBounds.Top

            ' g
            rect2 = New Rectangle(x, y, sizImage.Width + WSpace / 2, h - HSpace / 2)
            e.Graphics.DrawRectangle(Pens.LightGray, rect2)

            pr1 = sizImage.Height / sizImage.Width
            pr2 = img.Height / img.Width
            ThumbSize = sizImage
            ThumbMargin = New Size(0, 0)
            If pr1 < pr2 Then ' C[Wcɒꍇ
                ThumbMargin.Width = ThumbSize.Width
                ThumbSize.Width = ThumbSize.Width * (pr1 / pr2)
                ThumbMargin.Width = (ThumbMargin.Width - ThumbSize.Width) / 2
            Else
                ThumbMargin.Height = ThumbSize.Height
                ThumbSize.Height = ThumbSize.Height * (pr2 / pr1)
                ThumbMargin.Height = (ThumbMargin.Height - ThumbSize.Height) / 2
            End If

            e.Graphics.SmoothingMode = Drawing2D.SmoothingMode.AntiAlias
            e.Graphics.TextRenderingHint = Drawing.Text.TextRenderingHint.AntiAlias
            e.Graphics.DrawImage(img, x + ThumbMargin.Width, y + ThumbMargin.Height, ThumbSize.Width, ThumbSize.Height)
            If bShowName Then
                If imgd.strFile IsNot Nothing Then
                    rcText = New RectangleF(x, y + sizImage.Height, sizImage.Width, sizFont.Height)
                    e.Graphics.DrawString(imgd.strFile, f, Brushes.Black, rcText)
                End If
            End If
            If bShowComment Then
                If imgd.strComment IsNot Nothing Then
                    rcText = New RectangleF(x, y + sizImage.Height + sizFont.Height, sizImage.Width, sizFont.Height)
                    e.Graphics.DrawString(imgd.strComment, f, Brushes.Black, rcText)
                End If
            End If

            cntIn += 1
            cnt += 1
        Next
        m_iPage += 1

        If (cnt - 1) < (m_iPage * lines * col) Then
            e.HasMorePages = False
            m_iPage = 0
        Else
            e.HasMorePages = True
        End If

    End Sub

    ''' <summary>
    ''' xύXCxgBpXς邽߁AXg̍ēǂݍ݂s
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub FolderTreeView1_AfterLabelEdit(ByVal sender As System.Object, ByVal e As System.Windows.Forms.NodeLabelEditEventArgs) Handles FolderTreeView1.AfterLabelEdit
        PhotoListCtl1.SetImages(FolderTreeView1.SelectedNode.Name)
    End Sub

    ''' <summary>
    ''' _uNbNBL{^Ȃő剻Cxg𑗂
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub GraphicCollectorMain_MouseDoubleClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseDoubleClick
        If e.Button = Windows.Forms.MouseButtons.Left Then
            RaiseEvent MaximizeEvent()
        End If
    End Sub

    ''' <summary>
    ''' Xg̃_uNbNCxgBgʂ\B
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub PhotoListCtl1_DoubleClickEvent(ByVal sender As System.Object, ByVal e As MouseEventArgs) Handles PhotoListCtl1.DoubleClickEvent
        ShowItems()
    End Sub
#End Region

#Region "{^Cxg"
    ''' <summary>
    ''' {^
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub BtnClose_Click() Handles BtnClose.Click
        My.Settings.ShowComment = BtnComment.PushState
        My.Settings.ShowTitle = BtnTitle.PushState
        My.Settings.ThumbZoom = TrackThumbsize.Value
        My.Settings.MainWindowSize = Me.ParentForm.Size
        Dim x, y As Integer
        x = Me.ParentForm.Location.X
        y = Me.ParentForm.Location.Y
        If x < 0 Then
            x = 0
        End If
        If y < 0 Then
            y = 0
        End If
        My.Settings.MainWindowPos = New Point(x, y)
        RaiseEvent CloseEvent()
    End Sub

    ''' <summary>
    ''' ő剻{^
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub BtnMaximum_Click() Handles BtnMaximize.Click
        RaiseEvent MaximizeEvent()
    End Sub

    ''' <summary>
    ''' ŏ{^
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub BtnMinimum_Click() Handles BtnMinimize.Click
        RaiseEvent MinimizeEvent()
    End Sub

    ''' <summary>
    ''' XChV[{^
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub BtnSlideShow_Click() Handles BtnSlideShow.Click
        Dim imgd As ImageDataList

        ' IĂ摜̃Xg擾
        imgd = PhotoListCtl1.SelectedImages
        If imgd Is Nothing Then
            imgd = PhotoListCtl1.AllImages
        ElseIf imgd.Count <= 1 Then ' IĂ摜PȉȂSΏۂƂ
            imgd = PhotoListCtl1.AllImages
        End If
        If imgd Is Nothing Then
            Return
        End If
        If imgd.Count <= 0 Then ' 摜Ȃ璆f
            MessageBox.Show("摜܂", My.Application.Info.Title, MessageBoxButtons.OK)
            Return
        End If

        ' Oo
        Dim filelist As List(Of String) = New List(Of String)
        For Each img As ImageData In imgd
            filelist.Add(img.strName)
        Next

        ' XChV[s
        m_sshow = New SlideShowForm
        m_sshow.FileList = filelist
        m_sshow.Show()
    End Sub

    ''' <summary>
    ''' {^
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub BtnPrint_Click() Handles BtnPrint.Click
        m_iPage = 0
        PrintDialog1.Document = PrintDocument1
        If PrintDialog1.ShowDialog() = DialogResult.OK Then
            PrintPreviewDialog1.Document = PrintDialog1.Document
            PrintPreviewDialog1.ShowDialog()
        End If
    End Sub

    ''' <summary>
    ''' E։]{^
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub BtnTurnright_Click() Handles BtnTurnright.Click
        Dim imgdl As ImageDataList

        ' IĂ摜̃Xg擾
        imgdl = PhotoListCtl1.SelectedImages
        If imgdl Is Nothing Then
            imgdl = PhotoListCtl1.AllImages
        ElseIf imgdl.Count <= 0 Then ' IĂ摜
            MessageBox.Show("IĂ摜܂", My.Application.Info.Title, MessageBoxButtons.OK)
            Return
        End If
        If imgdl Is Nothing Then
            MessageBox.Show("摜܂", My.Application.Info.Title, MessageBoxButtons.OK)
            Return
        End If

        For Each imgd As ImageData In imgdl
            Try
                ImageLibs.ImageRotate(imgd.strName, RotateFlipType.Rotate90FlipNone)
            Catch ex As Exception
                MessageBox.Show("]ɃG[܂B", My.Application.Info.Title, MessageBoxButtons.OK)
            End Try
        Next
        PhotoListCtl1.ReloadAll()

    End Sub


    ''' <summary>
    ''' ։]{^
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub BtnTurnleft_Click() Handles BtnTurnleft.Click
        Dim imgdl As ImageDataList

        ' IĂ摜̃Xg擾
        imgdl = PhotoListCtl1.SelectedImages
        If imgdl Is Nothing Then
            imgdl = PhotoListCtl1.AllImages
        ElseIf imgdl.Count <= 0 Then ' IĂ摜
            MessageBox.Show("IĂ摜܂", My.Application.Info.Title, MessageBoxButtons.OK)
            Return
        End If
        If imgdl Is Nothing Then
            MessageBox.Show("摜܂", My.Application.Info.Title, MessageBoxButtons.OK)
            Return
        End If

        For Each imgd As ImageData In imgdl
            Try
                ImageLibs.ImageRotate(imgd.strName, RotateFlipType.Rotate270FlipNone)
            Catch ex As Exception
                MessageBox.Show("]ɃG[܂B", My.Application.Info.Title, MessageBoxButtons.OK)
            End Try
        Next
        PhotoListCtl1.ReloadAll()

    End Sub

    ''' <summary>
    ''' \{^
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub BtnPickup_Click() Handles BtnPickup.Click
        ShowItems()
    End Sub

    ''' <summary>
    ''' t@C\邩̃`FbN
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub BtnTitle_Click() Handles BtnTitle.Click
        If BtnTitle.PushState = True Then
            PhotoListCtl1.ShowFileName = True
        Else
            PhotoListCtl1.ShowFileName = False
        End If
    End Sub

    ''' <summary>
    ''' Jݒ肷
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub RadioButton1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioAutoColumn.CheckedChanged
        ComboColumn.Enabled = False
        m_bAutoColMode = True
        PhotoListCtl1.AutoColumn()
    End Sub

    ''' <summary>
    ''' J蓮ݒ肷
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub RadioButton2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioManualColumn.CheckedChanged
        ComboColumn.Enabled = True
        ComboColumn.Focus()
        m_bAutoColMode = False

        Dim column As Integer = 3
        Try
            column = CInt(ComboColumn.SelectedItem)
        Catch ex As Exception

        End Try

        If Not column = PhotoListCtl1.Columns Then
            PhotoListCtl1.Columns = column
        End If

    End Sub

    ''' <summary>
    ''' 蓮ݒ̃J̃XgύXꂽ
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub ComboColumn_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboColumn.SelectedIndexChanged
        If RadioManualColumn.Checked Then
            Dim column As Integer = 3
            Try
                column = CInt(ComboColumn.SelectedItem)
            Catch ex As Exception

            End Try

            If Not column = PhotoListCtl1.Columns Then
                PhotoListCtl1.Columns = column
            End If
        End If
    End Sub

    ''' <summary>
    ''' TlCTCYύXo[}EXꂽ
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub TrackThumbsize_MouseLeave(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackThumbsize.MouseLeave
        PhotoListCtl1.ThumbSize = New Size(600 - TrackThumbsize.Value * 12, 400 - TrackThumbsize.Value * 8)
        PhotoListCtl1.ReloadAll()

        If m_bAutoColMode = True Then
            PhotoListCtl1.AutoColumn()
        End If
    End Sub

    ''' <summary>
    ''' TlCTCYύXo[̒lύXꂽ
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub TrackThumbsize_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackThumbsize.ValueChanged
        PhotoListCtl1.ThumbSize = New Size(600 - TrackThumbsize.Value * 12, 400 - TrackThumbsize.Value * 8)
        PhotoListCtl1.ReloadAll()

        If m_bAutoColMode = True Then
            PhotoListCtl1.AutoColumn()
        End If
    End Sub

    ''' <summary>
    ''' TlCTCYύXo[̉̃C[WNbN
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub PictureBox4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureBox4.Click
        TrackThumbsize.Focus()
    End Sub
    Private Sub PictureBox3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureBox3.Click
        TrackThumbsize.Focus()
    End Sub

    ''' <summary>
    ''' Rg\邩ǂ̃`FbN{^
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub BtnCommnet_Click() Handles BtnComment.Click
        If BtnComment.PushState = True Then
            PhotoListCtl1.ShowComment = True
        Else
            PhotoListCtl1.ShowComment = False
        End If
    End Sub
#End Region

#Region "j[Cxg"
    ''' <summary>
    ''' GNXv[Nj[
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub TSMIExplorer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TSMTExplorer.Click
        Process.Start(FolderTreeView1.SelectedNode.Name)
    End Sub

    ''' <summary>
    ''' tH_̃Rs[j[
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub TSMTCopy_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TSMTCopy.Click
        FolderTreeView1.ClipCopyFolder()
    End Sub

    ''' <summary>
    ''' tH_̐VK쐬j[
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub TSMTNew_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TSMTNew.Click
        If FolderTreeView1.CreateNewFolder() = False Then
            MessageBox.Show("tH_쐬ł܂B", My.Application.Info.Title, MessageBoxButtons.OK)
        End If
    End Sub

    ''' <summary>
    ''' tH_̍폜j[
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub TSMTDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TSMTDelete.Click
        If FolderTreeView1.DeleteCurrentFolder() = False Then
            MessageBox.Show("tH_폜ł܂B", My.Application.Info.Title, MessageBoxButtons.OK)
        End If
    End Sub

    ''' <summary>
    ''' tH_̓\tj[
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub TSMTPaste_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TSMTPaste.Click
        If FolderTreeView1.PasteFolder() = False Then

        End If
    End Sub

    ''' <summary>
    ''' tH_̃l[j[
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub TSMTRename_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TSMTRename.Click
        FolderTreeView1.RenameFolder()
    End Sub

    ''' <summary>
    ''' ACẽRs[j[
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub TSMLCopy_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TSMLCopy.Click
        PhotoListCtl1.ClipCopyFiles()
    End Sub

    ''' <summary>
    ''' ACe̍폜j[
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub TSMLDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TSMLDelete.Click
        If PhotoListCtl1.DeleteFiles() = False Then
            MessageBox.Show("̃t@C폜ł܂łB", My.Application.Info.Title, MessageBoxButtons.OK)
        End If
    End Sub

    ''' <summary>
    ''' ACe̓\tj[
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub TSMLPaste_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TSMLPaste.Click
        PhotoListCtl1.PasteFolder()
    End Sub

    ''' <summary>
    ''' c[POPUPj[J悤ƂĂ鎞̐
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub CMSTreeWnd_Opening(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles CMSTreeWnd.Opening
        If FolderTreeView1.SelectedNode Is Nothing Then
            e.Cancel = True
        End If
        ' [g͍폜ƖO̕ύXłȂ悤ɂ
        If FolderTreeView1.SelectedNode.Parent Is Nothing Then
            TSMTDelete.Enabled = False
            TSMTRename.Enabled = False
        Else
            TSMTDelete.Enabled = True
            TSMTRename.Enabled = True
        End If
    End Sub

    ''' <summary>
    ''' XgPOPUPj[J悤ƂĂ鎞̐
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub CMSListWnd_Opening(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles CMSListWnd.Opening
        If PhotoListCtl1.SelectedImages.Count = 0 Then
            TSMLCopy.Enabled = False
            TSMLDelete.Enabled = False
        Else
            TSMLCopy.Enabled = True
            TSMLDelete.Enabled = True
        End If
    End Sub
#End Region


#Region "[U[֐"
    ''' <summary>
    ''' ACe̍ēǂݍ
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub ReloadItems()
        PhotoListCtl1.ReloadAll()
    End Sub

    ''' <summary>
    ''' IĂ摜\
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub ShowItems()
        Dim imgdl As ImageDataList
        Dim FileList As List(Of String) = New List(Of String)
        Dim cnt As Integer

        ' IĂ摜̃Xg擾
        imgdl = PhotoListCtl1.SelectedImages
        If imgdl Is Nothing Then
            Return
        ElseIf imgdl.Count <= 0 Then ' IĂ摜Ȃŏ̃C[W
            If PhotoListCtl1.AllImages.Count > 0 Then
                Dim imgd As ImageData
                imgd = PhotoListCtl1.AllImages.Item(0)
                imgdl.Add(imgd)
            Else
                MessageBox.Show("摜܂", My.Application.Info.Title, MessageBoxButtons.OK)
                Return
            End If
        End If

        If imgdl.Count > 4 Then
            If MessageBox.Show("̉摜JƂĂ܂B̂܂܊J܂H", My.Application.Info.Title, MessageBoxButtons.YesNo) = DialogResult.No Then
                Return
            End If
        End If
        For Each imgdAll As ImageData In PhotoListCtl1.AllImages
            FileList.Add(imgdAll.strName)
        Next

        For Each imgd As ImageData In imgdl
            cnt = 0
            For Each strList As String In FileList
                If imgd.strName.CompareTo(strList) = 0 Then
                    Dim photoViewer As New PhotoViewerForm(FileList, cnt)
                    If photoViewer.PhotoViewerImage IsNot Nothing Then
                        AddHandler photoViewer.ImageRefreshEvent, AddressOf ReloadItems
                        photoViewer.Show()
                    End If
                    Exit For
                End If
                cnt = cnt + 1
            Next
        Next
    End Sub
#End Region

#Region "vpeB"
    ''' <summary>
    ''' EBhȄ
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property WinState() As FormWindowState
        Get
            Return prop_WinState
        End Get
        Set(ByVal value As FormWindowState)
            prop_WinState = value

            If prop_WinState = FormWindowState.Maximized Then
                ' ő剻ꂽ
                BtnMaximize.NormalImage = My.Resources.W_btn_par_n
                BtnMaximize.HoverImage = My.Resources.W_btn_par_f
                BtnMaximize.PressedImage = My.Resources.W_btn_par_p
                Me.SizAble = False
                Me.MovAble = False
            Else
                ' ʏԂ̎
                BtnMaximize.NormalImage = My.Resources.W_btn_max_n
                BtnMaximize.HoverImage = My.Resources.W_btn_max_f
                BtnMaximize.PressedImage = My.Resources.W_btn_max_p
                Me.SizAble = True
                Me.MovAble = True
            End If
            Me.Invalidate()
        End Set
    End Property

#End Region

End Class
